%% binSearch
% Found de index of the the first Ddata element, y  <= x-deltax-em 
%
%% Description
% Author - 	
%           Ernesto Homar Teniente Aviles
% 			CONACYT Fellow
%			Institut de Robotica i Informatica Industrial, CSIC-UPC
%           Last change: 09/2008
%
% This code has been developed as part of the EU URUS Project
% FP6-IST-045062
% Usage
%
% Variables:
%   Inputs:
%       x       - a real, value to search
%       delta_x - a real, delta for the value to search
%       em      - a real, threshold for the value search
%       data    - nx1 , data 
%   Outputs: 
%       c_lowinx
%       c_uppinx
% 

%% Code:
function [c_lowinx c_uppinx] = binSearch(x,delta_x,em,data)

% TODO, REIMPLEMENT DE FUNCTION WITH ROUNDS , round down for the lower
% index, round upp for the upper limit and avoid using heuristic variables
% like delta or em

vlow =(x-delta_x);
vlow_low = vlow - em;
vlow_upp = vlow + em;
low_i = 1;
upp_i = size(data,1);
c_lowinx= round((upp_i)/2);
% Find the lower index by a binary search
while ((low_i+1) < upp_i);
%     fprintf(1,'\n index : %d value : %4.4f \n', [c_lowinxddata(cIndexLow,1)])
  if (vlow_low < data(c_lowinx)) && (data(c_lowinx) < vlow_upp);
    % It means the between vlow_low vlow_upp was found
    break        
  elseif data(c_lowinx) > vlow_low;
    upp_i = c_lowinx;
  else data(c_lowinx) < vlow_low;
    low_i = c_lowinx;
  end
  c_lowinx= round((upp_i+low_i-1)/2);
end

% Find the upper index by a binary search
vupp =(x+delta_x);
vupp_low = vupp - em;
vupp_upp = vupp + em;
low_i = 1;
upp_i = size(data,1);
c_uppinx = round((upp_i)/2);
% c_uppinx = round((upp_i+low_i-1)/2);
while ((low_i+1) < upp_i);
  if (vupp_low > data(c_uppinx)) && (data(c_uppinx) > vupp_upp);
    % It means the between vupp_low vupp_upp was found
    break        
  elseif data(c_uppinx) > vupp_low;
    upp_i = c_uppinx;
  else data(c_uppinx) < vupp_low;
    low_i = c_uppinx;
  end
  c_uppinx = round((upp_i+low_i)/2);
end


