% DRAWAXIS -
%
% Usage:
%   drawaxis(H,scale,label)
%
% draw an axis on position [0,0,0]
% transformed at coordinate frame H, with axis scale long
%
%
% TODO: To be able to change axis colors

% CODE:
function done = drawaxis(H,scale,label)


o=[0;0;0;1];
ox=[scale;0;0;1];
oy=[0;scale;0;1];
oz=[0;0;scale;1];

po=H*o;
px=H*ox;
py=H*oy;
pz=H*oz;

line([po(1) px(1)],[po(2) px(2)],[po(3) px(3)],'color',[1 0 0]);
text(px(1), px(2), px(3), 'X');
line([po(1) py(1)],[po(2) py(2)],[po(3) py(3)],'color',[0 1 0]);
text(py(1), py(2), py(3), 'Y');
line([po(1) pz(1)],[po(2) pz(2)],[po(3) pz(3)],'color',[0 0 1]);
text(pz(1), pz(2), pz(3), 'Z');
if isnumeric(label)
  text(po(1)+scale/4, po(2), po(3)+scale/4, num2str(label));
else
  text(po(1)+scale/4, po(2), po(3)+scale/4, label);  
end