% SYNCDEVICEDATAWODOMETRY
% Sync one device reading with it corresponding odometry pose finding the
% same time stamp
%

% input -
%   query_device - a struct .SRC
%                           .File
%                           .
%                           .
%   odometry -  a struct  .data(3/6) x n matrix
%                         .type
%                         .ts

%% CODE -

function sync = syncDeviceDataWOdometry(query_device,odometry)


device =query_device(1,1).Device;
devicesz = size(query_device,2);

switch device
    case 'laser3d'
      ts = zeros(devicesz);
      for i = 1:devicesz
        scan = getHokuyo3DTimeStamps(query_device(1,i).File);
        ts(i) = scan.ts.ini.sec;
      end
    case 'compass'
        ts = query_devices.ts;
    case 'GPS'
        %TODO
    case 'stereoCameras'
        %TODO
    case 'networkCameras'
        %TODO
    otherwise
        error('Wrong or misspelling device!');
end

odometry_fields = fieldnames(odometry);
inx= syncTimeStamps(ts,odometry.ts);

switch odometry(1).type
  case '6D'
    % TODO, identifie, the odometry type x y z, pose,
    if (strcmp('x',odometry_fields{1}))
      sync.x = odometry.x(1,inx);
      sync.y = odometry.y(1,inx);
      sync.z = odometry.z(1,inx);
      sync.rx = odometry.rx(1,inx);
      sync.ry = odometry.ry(1,inx);
      sync.rz = odometry.rz(1,inx);
    end
    if (strcmp('pose',odometry_fields{1}))
      sync.pose = odometry.pose(:,inx);
    end

  case '3D'
     if (strcmp('x',odometry_fields{1}))
        sync.pose.x = odometry.x(1,inx);
        sync.pose.y = odometry.y(1,inx);
        sync.pose.theta = odometry.theta(1,inx);
     end
     if (strcmp('pose',odometry_fields{1}))
      sync.pose = odometry.pose(:,inx);
     end
end


  sync.ts = odometry.ts(inx);
