function show_odometry_and_compass(varargin)

% Barcelona Robot Lab Data Set (BRL)
% IRI Mobile Robotics Group, 2011

%% path dataset xlm
s = filesep;
if nargin < 1
  % Default directory
  root_dir = ['..' s '..' s 'eval_data_set'];  
else
  % your data set directory
  root_dir = varargin{1};
end

initParseTools('.');

%% images path
path_odo=[ root_dir '/20101021_odometry_ft.xml'];
path_comp=[ root_dir '/20101021_compass_ft.xml'];
%infomation from xmls
files.odometry = getFilesParam(path_odo);
files.compass = getFilesParam(path_comp);

%% Create file 

for i=1:size(files.odometry,2)
  odometry(:,i).File = [root_dir  files.odometry(i).SRC '/' files.odometry(i).File];
end
for i=1:size(files.compass,2)
  compass_(i,:) = [root_dir  files.compass(i).SRC '/' files.compass(i).File];
end

%% Sync

rbtOdometry.all= joinOdometryFiles(odometry,'DataType',2); 
odometry6D = pose2Dto3D(rbtOdometry.all.pose);
odometry6D.ts = rbtOdometry.all.ts;
% syncronize Laser and Odometry
tmp_pose.pose = pose3DAddCompass(odometry6D,compass_);

%% Plotting
% plot odometry (x,y,z)
plot3(tmp_pose.pose(1,:),tmp_pose.pose(2,:),tmp_pose.pose(3,:),'.b',...
      'MarkerSize',4)
hold on
% plot some robot orientations
      j=1;
for i=1:1000:size(tmp_pose.pose,2)
    drawaxis([rxryrz2R(tmp_pose.pose(4,i),tmp_pose.pose(5,i),tmp_pose.pose(6,i)) ...
            tmp_pose.pose(1:3,i);0 0 0 1],1,i);
          j =j+1;
end

axis equal


